<template>
  <div class="p-2">
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="600px" :draggable="draggable">
      <el-form ref="formRef" v-loading="formLoading" :model="formData" :rules="formRules" label-width="80px">
        <el-form-item label="餐类名称" prop="mealName">
          <el-select v-model="formData.mealName" placeholder="请选择餐类名称" @change="selectMealType($event)">
            <el-option
                v-for="dict in meal_type"
                :key="dict.label"
                :label="dict.label"
                :value="{mealName: dict.label, typeId:dict.value}"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="开始时间" prop="beginTime">
          <el-time-select v-model="formData.beginTime" :max-time="formData.endTime" style="width: 240px" start="05:00"
          step="00:15" end="23:59" format="HH:mm:ss" placeholder="请选择时间"/>
        </el-form-item>
        <el-form-item label="结束时间" prop="endTime">
          <el-time-select v-model="formData.endTime" :min-time="formData.beginTime" style="width: 240px" start="05:00"
          step="00:15" end="23:59" format="HH:mm:ss" placeholder="请选择结束时间"/>
        </el-form-item>
        <el-form-item label="类别说明" prop="mealNotes">
          <el-input v-model="formData.mealNotes" placeholder="请输入类别说明" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="formLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="dialog.visible = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PtMealtypeForm" lang="ts">
import * as PtMealtypeApi from '@/api/basics/basicParameter/ptMealtype';
import { PtMealTypeForm } from '@/api/basics/basicParameter/ptMealtype/types';
import { useI18n } from 'vue-i18n';

defineOptions({ name: 'PtMealtypeForm' });

// 接收父组件传入属性
// const props = defineProps({})
/** 数据字典 */

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
// 国际化
const { t } = useI18n();

const { meal_type } = toRefs<any>(proxy?.useDict('meal_type'));
// 对话框
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
// 窗体是否可以拖动
const draggable = ref(true);
// 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formLoading = ref(false);
// 表单的类型：create - 新增；update - 修改
const formType = ref('');
// 表单引用
const formRef = ref<ElFormInstance>();
// 表单数据
const formData = ref<PtMealTypeForm>({
  mealId: undefined,
  typeId: undefined,
  mealName: '',
  beginTime: '',
  endTime: '',
  mealNotes: '',
});
// 表单校验规则
const formRules = reactive({
  mealId: [{ required: true, message: '营业时段id不能为空', trigger: 'blur' }],
  mealName: [{ required: true, message: '餐类名称不能为空', trigger: 'blur' }],
  beginTime: [{ required: true, message: '开始时间不能为空', trigger: 'blur' }],
  endTime: [{ required: true, message: '结束时间不能为空', trigger: 'blur' }],
});
/** 当前组件方法 */
/** 窗体打开事件 */
const open = async (type: string, id?: number) => {
  dialog.visible = true;
  dialog.title = t('action.' + type);
  formType.value = type;
  resetForm();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true;
    try {
      const res = await PtMealtypeApi.getPtMealtype(id);
      Object.assign(formData.value, res.data);
    } finally {
      formLoading.value = false;
    }
  }
};
/** 表单重置 */
const resetForm = () => {
  formData.value = {
    mealId: undefined,
    mealName: '',
    beginTime: '',
    endTime: '',
    mealNotes: '',
  };
  formRef.value?.resetFields();
};

const selectMealType = (event) => {
  formData.value.typeId = event.typeId
  formData.value.mealName = event.mealName
}
// 传回给父组件的属性与方法
// 提供 open 方法，用于打开弹窗
defineExpose({ open });
/** 触发父组件的事件 */
/** 定义 success 事件，用于操作成功后的回调 */
const emit = defineEmits(['success']);
/** 提交按钮 */
const submitForm = async () => {
  // 校验表单
  if (!formRef) return;
  const valid = await formRef.value?.validate();
  if (!valid) return;
  // 提交请求
  formLoading.value = true;
  try {
    const data = formData.value as unknown as PtMealTypeForm;
    if (formType.value === 'create') {
      await PtMealtypeApi.addPtMealtype(data);
      proxy?.$modal.msgSuccess('新增成功');
    } else {
      await PtMealtypeApi.updatePtMealtype(data);
      proxy?.$modal.msgSuccess('修改成功');
    }
    dialog.visible = false;
    // 发送操作成功的事件
    emit('success');
  } finally {
    formLoading.value = false;
  }
};

/** 初始化 */
onMounted(() => {});
</script>
